-- 正计时  倒计时方法
w,h = getScreenSize();
function mTimer(num,timerType)
	local mLen = string.len(tostring(num))
	if timerType == 0 then
		for var= 1, num do
			showTextView(var.."",w/2-mLen*10-30,h*0.8,w/2+mLen*10+30,h*0.84,"center","FFFFFF","000000",20,1,0.5,0,{alpha = 0.5,radius = 15})
			mSleep(1000)
		end
		closeTextView()
	else
		for var= num, 1, -1 do
			showTextView(var.."",w/2-mLen*10-30,h*0.8,w/2+mLen*10+30,h*0.84,"center","FFFFFF","000000",20,1,0.5,0,{alpha = 0.5,radius = 15})
			mSleep(1000)
		end
		closeTextView()
	end
end

-- 查找控件并操作
function mWidgetInspectorFind(id,text,TYPE,desc,ms,bool,toast_str,operationType)
	local varWidget = widget.find({["id"] = id, ["text"] = text, ["type"] = TYPE, ["desc"] = desc})
	if varWidget ~= nil then
		if bool then toast(toast_str) end
		if (widget.clickable(varWidget)) then
			widget.click(varWidget)
		else
			x, y, x1, y1 = widget.region(varWidget)
			event.tap(x + (x1 - x) / 2, y + (y1 - y) / 2)
		end
        mSleep(ms)
		if operationType==1 then
        	keycode.back()
        elseif operationType==2 then
        	keycode.home()
        end
	end
end

--滑动按时间执行
function mMove(x,y,x1,y1,sleepTime)
    local t0=os.time()
    while true do
        event.moveTo(x,y,x1,y1,1000);
        mSleep(1000);
        local t1=os.time();
        if t1-t0>=(sleepTime/1000) then
            break;
        end
    end
end

--滑动按次数执行
function mMoveCount(x,y,x1,y1,count)
    for var= 1, count do
	   event.moveTo(x, y, x1, y1, 1000);
	   mSleep(1000);
    end
end

--点击按时间执行
function mTap(x,y,sleepTime)
    local t0=os.time()
    while true do
        event.tap(x,y,100);
        mSleep(100);
        local t1=os.time();
        if t1-t0>=(sleepTime/1000) then
            break;
        end
    end
end

--点击按次数执行
function mTapCount(x,y,count)
    for var= 1, count do
	   event.tap(x, y, 100);
	   mSleep(1000);
    end
end

--长按按时间执行
function mPress(x,y,sleepTime)
    event.press(x, y, sleepTime);
	mSleep(sleepTime);
end

--长按按次数执行
function mPressCount(x,y,count)
    for var= 1, count do
	   event.press(x, y, 800);
	   mSleep(1000);
    end
end

--控件输入文本
function widgetInput(varWidget,content)
    if varWidget ~= nil then
        widget.setText(content);
    end
end

--滑动控件
function widgetSwipe(varWidget,orientation)
    if varWidget ~= nil then
        if orientation == 0 then
            widget.scrollBackward(varWidget);
        else
            widget.scrollForward(varWidget);
        end
    end
end

--长按控件
function widgetPress(varWidget)
    if varWidget ~= nil then
        widget.longClick(varWidget);
    end
end

--点击控件
function widgetClick(varWidget)
    if varWidget ~= nil then
        widget.click(varWidget);
    end
end

--查找控件并操作
function widgetFind(varType,rule,which,content,orientationType,moveToType,finishSleepTime)
    local varWidget;
    if varType == 2 then
        varWidget = widget.find({["id"]=content,["rule"]=rule,["which"]=which});
    elseif varType == 1 then
        varWidget = widget.find({["desc"]=content,["rule"]=rule,["which"]=which});
    else
        varWidget = widget.find({["text"]=content,["rule"]=rule,["which"]=which});
    end
    if varWidget ~= nil then
        if orientationType == 0 then
            if (widget.clickable(varWidget)) then
            	widget.click(varWidget)
            else
            	x, y, x1, y1 = widget.region(varWidget)
            	event.tap(x + (x1 - x) / 2, y + (y1 - y) / 2)
            end
        elseif orientationType == 2 then
            if moveToType == 0 then
                 widget.scrollBackward(varWidget);
            else
                 widget.scrollForward(varWidget);
            end
        else
            x,y,x1,y1 = widget.region(varWidget);
            event.press(x+(x1-x)/2,y+(y1-y)/2);
        end
    end
    mSleep(finishSleepTime);
end





